## ros-kinetic-ar-track-alvar 0.7.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(ar_track_alvar)

set(MSG_DEPS
    ar_track_alvar_msgs
    std_msgs
    sensor_msgs
    geometry_msgs
    visualization_msgs)

find_package(catkin COMPONENTS
        genmsg
        roscpp
        tf
        tf2
        image_transport
        resource_retriever
        cv_bridge
        pcl_ros
        pcl_conversions
        message_generation
        ${MSG_DEPS}
        dynamic_reconfigure
        cmake_modules
        REQUIRED)

find_package(Eigen3 REQUIRED)
find_package(OpenCV REQUIRED)
find_package(TinyXML REQUIRED)

include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)
if(COMPILER_SUPPORTS_CXX11)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
elseif(COMPILER_SUPPORTS_CXX0X)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
else()
        message(STATUS "The compiler ${CMAKE_CXX_COMPILER} has no C++11 support. Please use a different C++ compiler.")
endif()

cmake_policy(SET CMP0046 OLD)

# dynamic reconfigure support
generate_dynamic_reconfigure_options(cfg/Params.cfg)

catkin_package(
  INCLUDE_DIRS include
  LIBRARIES ar_track_alvar
  CATKIN_DEPENDS
        ar_track_alvar_msgs
        std_msgs
        roscpp
        tf
        tf2
        message_runtime
        image_transport
        sensor_msgs
        geometry_msgs
        visualization_msgs
        resource_retriever
        cv_bridge
        pcl_ros
        pcl_conversions
        dynamic_reconfigure
)

include_directories(include 
                    ${catkin_INCLUDE_DIRS}
                    ${OpenCV_INCLUDE_DIRS}
                    ${TinyXML_INCLUDE_DIRS}

)

set(GENCPP_DEPS ar_track_alvar_msgs_gencpp std_msgs_gencpp sensor_msgs_gencpp geometry_msgs_gencpp visualization_msgs_gencpp)

add_library(ar_track_alvar
    src/Camera.cpp
    src/CaptureDevice.cpp
    src/Pose.cpp
    src/Marker.cpp
    src/MarkerDetector.cpp
    src/Bitset.cpp
    src/Rotation.cpp
    src/CvTestbed.cpp
    src/CaptureDevice.cpp
    src/CaptureFactory.cpp
    src/CaptureFactory_unix.cpp
    src/FileFormatUtils.cpp
    src/Threads.cpp
    src/Threads_unix.cpp
    src/Mutex.cpp
    src/Mutex_unix.cpp
    src/ConnectedComponents.cpp
    src/Line.cpp src/Plugin.cpp
    src/Plugin_unix.cpp
    src/DirectoryIterator.cpp
    src/DirectoryIterator_unix.cpp
    src/Draw.cpp
    src/Util.cpp
    src/Filter.cpp
    src/Kalman.cpp
    src/kinect_filtering.cpp
    src/Optimization.cpp
    src/MultiMarker.cpp
    src/MultiMarkerBundle.cpp
    src/MultiMarkerInitializer.cpp)
target_link_libraries(ar_track_alvar ${OpenCV_LIBS} ${TinyXML_LIBRARIES} ${catkin_LIBRARIES})
add_dependencies(ar_track_alvar ${GENCPP_DEPS})

# Kinect filtering code
set(KINECT_FILTERING_TARGETS kinect_filtering medianFilter)

add_library(kinect_filtering src/kinect_filtering.cpp)
target_link_libraries(kinect_filtering ${catkin_LIBRARIES})
add_dependencies(kinect_filtering ${GENCPP_DEPS})

add_library(medianFilter src/medianFilter.cpp)
target_link_libraries(medianFilter ar_track_alvar ${catkin_LIBRARIES})
add_dependencies(medianFilter ${GENCPP_DEPS})

set(ALVAR_TARGETS ar_track_alvar individualMarkers individualMarkersNoKinect trainMarkerBundle findMarkerBundles findMarkerBundlesNoKinect createMarker ar_track_alvar)

add_executable(individualMarkers nodes/IndividualMarkers.cpp)
target_link_libraries(individualMarkers ar_track_alvar kinect_filtering ${catkin_LIBRARIES})
add_dependencies(individualMarkers ${PROJECT_NAME}_gencpp ${GENCPP_DEPS} ${PROJECT_NAME}_gencfg)

add_executable(individualMarkersNoKinect nodes/IndividualMarkersNoKinect.cpp)
target_link_libraries(individualMarkersNoKinect ar_track_alvar ${catkin_LIBRARIES})
add_dependencies(individualMarkersNoKinect ${PROJECT_NAME}_gencpp  ${GENCPP_DEPS} ${PROJECT_NAME}_gencfg)

add_executable(trainMarkerBundle nodes/TrainMarkerBundle.cpp)
target_link_libraries(trainMarkerBundle ar_track_alvar ${catkin_LIBRARIES})
add_dependencies(trainMarkerBundle ${PROJECT_NAME}_gencpp ${GENCPP_DEPS})

add_executable(findMarkerBundles nodes/FindMarkerBundles.cpp)
target_link_libraries(findMarkerBundles ar_track_alvar kinect_filtering medianFilter ${catkin_LIBRARIES})
add_dependencies(findMarkerBundles ${PROJECT_NAME}_gencpp ${GENCPP_DEPS})

add_executable(findMarkerBundlesNoKinect nodes/FindMarkerBundlesNoKinect.cpp)
target_link_libraries(findMarkerBundlesNoKinect ar_track_alvar ${catkin_LIBRARIES})
add_dependencies(findMarkerBundlesNoKinect ${PROJECT_NAME}_gencpp ${GENCPP_DEPS})

add_executable(createMarker src/SampleMarkerCreator.cpp)
target_link_libraries(createMarker ar_track_alvar ${catkin_LIBRARIES})
add_dependencies(createMarker ${PROJECT_NAME}_gencpp ${GENCPP_DEPS})

install(TARGETS ${ALVAR_TARGETS} ${KINECT_FILTERING_TARGETS}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

install(DIRECTORY launch bundles
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/
)

if (CATKIN_ENABLE_TESTING)
  find_package(catkin REQUIRED COMPONENTS roslaunch rostest)
  
  file(GLOB LAUNCH_FILES launch/*.launch test/*.test)
  foreach(LAUNCH_FILE ${LAUNCH_FILES})
    roslaunch_add_file_check(${LAUNCH_FILE} USE_TEST_DEPENDENCIES)
  endforeach()
  
  catkin_download_test_data(
    ${PROJECT_NAME}_4markers_tork.bag
    http://download.ros.org/data/ar_track_alvar/ar_track_alvar_4markers_tork_2017-02-08-11-21-14.bag
    # Workaround the issue http://answers.ros.org/question/253787/accessing-data-downloaded-via-catkin_download_test_data/
    # by downloading into source folder.
    #DESTINATION ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/test
    DESTINATION ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/test
    MD5 627aa0316bbfe4334e06023d7c2b4087
   )
  add_rostest(test/marker_arg_config-basic.test DEPENDENCIES ${PROJECT_NAME}_4markers_tork.bag)
  add_rostest(test/marker_arg_config-full.test DEPENDENCIES ${PROJECT_NAME}_4markers_tork.bag)
  add_rostest(test/marker_param_config-basic.test DEPENDENCIES ${PROJECT_NAME}_4markers_tork.bag)
  add_rostest(test/marker_param_config-full.test DEPENDENCIES ${PROJECT_NAME}_4markers_tork.bag)
endif()

=== debian/changelog ===
ros-kinetic-ar-track-alvar (0.7.1-0xenial) xenial; urgency=high

  * [maintenance] Remove unnecessary metapkg.
  * [fix][build][CMakeLists] Prevent rosdep errors that only occur when running tests with catkin_make_isolated. See http://answers.ros.org/question/262558/buildfarm-missing-package-dependencies-pkg_namepackagexml/
  * [test] Relax tf test criteria #39 <https://github.com/ros-perception/ar_track_alvar/pull/39>
  * Contributors: Isaac I.Y. Saito

 -- Scott Niekum <sniekum@cs.umass.edu>  Wed, 14 Jun 2017 07:00:00 -0000

ros-kinetic-ar-track-alvar (0.7.0-0xenial) xenial; urgency=high

  * Consolidate ar_track_alvar* packages into a single repo (#120 <https://github.com/sniekum/ar_track_alvar/issues/120>)
  * Contributors: Isaac I.Y. Saito

 -- Scott Niekum <sniekum@cs.umass.edu>  Fri, 21 Apr 2017 07:00:00 -0000

ros-kinetic-ar-track-alvar (0.6.3-0xenial) xenial; urgency=high

  * [fix] Marker no longer recognized, for IndividualMarkersNoKinect #93 <https://github.com/sniekum/ar_track_alvar/issues/93>
  * [capability] Add param to derive camera frame from pointcloud message frame (#111 <https://github.com/sniekum/ar_track_alvar/issues/111>)
  * [capability ] individual marker nodes: replace command line args with ros parameters (#99 <https://github.com/sniekum/ar_track_alvar/issues/99>)
  * [maintenance] Add system test using .bag. (#106 <https://github.com/sniekum/ar_track_alvar/issues/106>)
  * Contributors: Hans-Joachim Krauch, Isaac I.Y. Saito

 -- Scott Niekum <sniekum@cs.umass.edu>  Thu, 09 Feb 2017 08:00:00 -0000

ros-kinetic-ar-track-alvar (0.6.2-0xenial) xenial; urgency=high

  * [fix] Marker no longer recognized #93 <https://github.com/sniekum/ar_track_alvar/issues/93>
  * [fix] add install rule for bundles folder; fixes #88 <https://github.com/sniekum/ar_track_alvar/issues/88>
  * [fix] Shutdown camera info sub after called
  * [enhancement] add mark_resolution and mark_marge as input option
  * [enhancement] individualMarkers: replace cout with ROS_DEBUG_STREAM (#101 <https://github.com/sniekum/ar_track_alvar/issues/101>)
  * Contributors: Alex Reimann, Hans-Joachim Krauch, Isaac I.Y. Saito, TORK Developer 534

 -- Scott Niekum <sniekum@cs.umass.edu>  Tue, 07 Feb 2017 08:00:00 -0000

ros-kinetic-ar-track-alvar (0.6.1-0xenial) xenial; urgency=high

  * New parameter -array to create an array of markers #85 <https://github.com/sniekum/ar_track_alvar/issues/85> from 130s/kinetic/add_60
  * Fix build for Kinetic by adding missing dependencies on gencfg #84 <https://github.com/sniekum/ar_track_alvar/issues/84> from 130s/kinetic/fix_buildfarm
  * [sys] Add a maintainer to receive notification from ros buildfarm.
  * Contributors: Jackie Kay, Mehdi, Isaac I.Y. Saito

 -- Scott Niekum <sniekum@cs.umass.edu>  Wed, 08 Jun 2016 07:00:00 -0000

ros-kinetic-ar-track-alvar (0.6.0-0xenial) xenial; urgency=high

  * Made compatible to ROS-Kinetic-Kame #80 <https://github.com/sniekum/ar_track_alvar/issues/80>
  * [Travis CI] Add ROS Kinetic support. Add Prerelease Test on Travis #79 <https://github.com/sniekum/ar_track_alvar/issues/79>
  * Contributors: Sepehr MohaimenianPour, Isaac I.Y. Saito

 -- Scott Niekum <sniekum@cs.umass.edu>  Wed, 01 Jun 2016 07:00:00 -0000

ros-kinetic-ar-track-alvar (0.5.3-0xenial) xenial; urgency=high

  * [feat] New bool-Topic to enable/disable the marker detection (#70 <https://github.com/sniekum/ar_track_alvar/issues/70>)
  * [feat] added public way to set intrinsicCalibration for Camera class
  * [fix] not publishing marker that are facing in the same direction as the camera.
  * [sys] removed duplicate code for image subscription
  * Contributors: Nikolas Engelhard, Scott Niekum

 -- Scott Niekum <sniekum@cs.umass.edu>  Tue, 02 Feb 2016 08:00:00 -0000

ros-kinetic-ar-track-alvar (0.5.2-0xenial) xenial; urgency=high

  * [fix] Move tf include from header to cpp files, fixes #66 <https://github.com/sniekum/ar_track_alvar/issues/66>
    The header currently prevents us from re-using the library as a given library (because it pulls in tf2 which causes trouble). The include has been moved to the individual nodes which actually use a TransformBroadcaster.
  * [fix] proper virtual destruction #63 <https://github.com/sniekum/ar_track_alvar/issues/63>.
  * improve license information in package.xml (#58 <https://github.com/sniekum/ar_track_alvar/issues/58>)
  * Added time stamp to header (#57 <https://github.com/sniekum/ar_track_alvar/issues/57>)
    Previously, each pose had a timestamp, but the whole message did not. By including the timestamp for the whole message, it is now possible to use the results of the ar_pose_marker topic with other messages using message_filters::Synchronizer.
  * Contributors: Alex Henning, Bener Suay, Lukas Bulwahn, Scott Niekum, Tim Niemueller, Isaac I. Y. Saito

 -- Scott Niekum <sniekum@cs.umass.edu>  Fri, 27 Nov 2015 08:00:00 -0000

ros-kinetic-ar-track-alvar (0.5.1-0xenial) xenial; urgency=high

  * Remove meta pkg; ar_track_alvar is 'unary stack' so no need for the meta pkg.
  * Contributors: Scott Niekum, Isaac IY Saito

 -- Scott Niekum <sniekum@cs.umass.edu>  Tue, 14 Apr 2015 07:00:00 -0000

ros-kinetic-ar-track-alvar (0.5.0-0xenial) xenial; urgency=high

  * move README to root directory
  * Merge remote-tracking branch 'origin/hydro-devel' into indigo-devel
  * ar_track_alvar package uses ar_track_alvar_msgs
  * restructuring packages. Separate out the message package.
  * Contributors: Jihoon Lee

 -- Scott Niekum <sniekum@cs.umass.edu>  Wed, 25 Jun 2014 07:00:00 -0000

ros-kinetic-ar-track-alvar (0.4.1-0xenial) xenial; urgency=high



 -- Scott Niekum <sniekum@cs.umass.edu>  Thu, 28 Nov 2013 08:00:00 -0000

ros-kinetic-ar-track-alvar (0.3.3-0xenial) xenial; urgency=high



 -- Scott Niekum <sniekum@cs.umass.edu>  Fri, 22 Feb 2013 08:00:00 -0000

ros-kinetic-ar-track-alvar (0.3.2-0xenial) xenial; urgency=high



 -- Scott Niekum <sniekum@cs.umass.edu>  Mon, 18 Feb 2013 08:00:00 -0000



=== debian/control ===
Source: ros-kinetic-ar-track-alvar
Section: misc
Priority: extra
Maintainer: Scott Niekum <sniekum@cs.umass.edu>
Build-Depends: debhelper (>= 9.0.0), libtinyxml-dev, ros-kinetic-ar-track-alvar-msgs, ros-kinetic-catkin, ros-kinetic-cmake-modules, ros-kinetic-cv-bridge, ros-kinetic-dynamic-reconfigure, ros-kinetic-geometry-msgs, ros-kinetic-image-transport, ros-kinetic-message-generation, ros-kinetic-pcl-conversions, ros-kinetic-pcl-ros, ros-kinetic-resource-retriever, ros-kinetic-rosbag, ros-kinetic-roscpp, ros-kinetic-rospy, ros-kinetic-rostest, ros-kinetic-sensor-msgs, ros-kinetic-std-msgs, ros-kinetic-tf, ros-kinetic-tf2, ros-kinetic-visualization-msgs
Homepage: http://ros.org/wiki/ar_track_alvar
Standards-Version: 3.9.2

Package: ros-kinetic-ar-track-alvar
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libtinyxml-dev, ros-kinetic-ar-track-alvar-msgs, ros-kinetic-cv-bridge, ros-kinetic-dynamic-reconfigure, ros-kinetic-geometry-msgs, ros-kinetic-image-transport, ros-kinetic-message-runtime, ros-kinetic-pcl-conversions, ros-kinetic-pcl-ros, ros-kinetic-resource-retriever, ros-kinetic-roscpp, ros-kinetic-rospy, ros-kinetic-sensor-msgs, ros-kinetic-std-msgs, ros-kinetic-tf, ros-kinetic-tf2, ros-kinetic-visualization-msgs
Description: This package is a ROS wrapper for Alvar, an open source AR tag tracking library.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-ar-track-alvar//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
